#include "common.h"
#include "com.h"
#include "kcomm.h"
#include "mainWnd.h"
#include "addrWnd.h"
#include "passWnd.h"
#include "aeeWnd.h"
#include "png.h"
#include "emoji.h"

HWND hAddrWnd = NULL;

#define GetDlgItemTextLength(hDlg, nID) GetWindowTextLength(GetDlgItem(hDlg, nID))

DWORD ListView_GetColumnCount(HWND hWnd)
{
	LV_COLUMN lvc;
	DWORD count = 0;

	lvc.mask = LVCF_SUBITEM;
	while(ListView_GetColumn(hWnd, count, &lvc))
		count++;

	return count;
}

void ListView_SetItemTextByName(HWND hWnd, UINT index, char* cname, char* text)
{
	UINT i;

	for(i = 0; i < ListView_GetColumnCount(hWnd); i++)
	{
		LV_COLUMN lvc;
		char cn[256];

		lvc.mask = LVCF_TEXT;
		lvc.pszText = cn;
		lvc.cchTextMax = sizeof(cn);

		ListView_GetColumn(hWnd, i, &lvc);

		if(!strcomp(cn, cname))
		{
			ListView_SetItemText(hWnd, index, i, text);
			break;
		}
	}

	return;
}

void getAddresses(HWND hWnd)
{
	BYTE cmd[32];
	HANDLE hcom;
	BYTE* data;
	DWORD size;
	char pass[9];
	char group[20][32];	// oh kimeuchi!!

	pass[0] = '\0';
	if(1 <= GetDlgItemTextLength(hMainWnd, IDC_LOCKNO) &&
		GetDlgItemTextLength(hMainWnd, IDC_LOCKNO) <= 8)
		GetDlgItemText(hMainWnd, IDC_LOCKNO, pass, 9);
	if(DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_PASSDIALOG), hWnd, PassWndProc, (LPARAM)pass))
		pass[0] = '\0';

	Log("<<GetAddress>>\r\n");

	Log("beginComm...");
	if(beginComm(&hcom))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	// for secret items...
	if(strlength(pass))
	{
		Log("Send lockNo...");
		cmd[0] = 0x00;
		cmd[1] = 0x21;
		strncopy(cmd + 2, pass, strlength(pass));
		if(sendCommand(hcom, cmd, 2 + strlength(pass), FALSE))
		{
			Log("Send failed\r\n");
			goto error;
		}
		if(ReadByte(hcom) != 0x06)
		{
			Log("NAK\r\n");
			if(endComm(hcom))
				CloseHandle(hcom);
			MessageBox(hWnd, "NAK returned.\nThis indicates LockNo mismatched.\n\nTransferring aborted.", "LockNo mismatch!", MB_ICONWARNING | MB_OK);
			return;
		}
		Log("OK\r\n");
	}

	Log("Getting GroupList...");
	cmd[0] = 0x02;
	cmd[1] = 0x20;
	cmd[2] = 0x02;
	cmd[3] = 0x03;
	cmd[4] = 0x00;
	cmd[5] = 0x00;
	if(sendCommand(hcom, cmd, 6, FALSE))
	{
		Log("Send failed\r\n");
		goto error;
	}
	if(ReadByte(hcom) != 0x06)
	{
		Log("NAK\r\n");
		goto error;
	}
	if(getResult(hcom, &data, &size))
	{
		Log("Read error\r\n");
		goto error;
	}
	Log("OK\r\n");

	Log("Parsing Group...");
	{
		BYTE* b = data;

		while((DWORD)(b - data) < size)
		{
			if(*b != 0x1C)
			{
				Log("RecordFirst not found\r\n");
				goto groupParseError;
			}
			b++;

			while((DWORD)(b - data) < size)
			{
				WORD psize;
				BYTE cmd;
				static num = 0;

				if(*b == 0x1C)
					break;

				if(*b != 0x1E)
				{
					Log("RecordByte not found\r\n");
					goto groupParseError;
				}
				b++;

				cmd = *b++;

				psize = (b[0] << 8) | b[1];
				b += 2;

				switch(cmd)
				{
				case 0x01:	// num
					num = (b[0] << 8) | b[1];
					break;
				case 0x02:	// name
					strncopy(group[num], b, psize);
					group[num][psize] = '\0';
					break;
				default:
					Log("Unknown group field ");
					LogHex(cmd);
					Log(":");
					LogDump(b, psize);
					Log("\r\n");
					break;
				}

				b += psize;
			}
		}
	}
	Log("OK\r\n");

	Log("Getting AddressList...");
	cmd[0] = 0x02;
	cmd[1] = 0x20;
	cmd[2] = 0x01;
	cmd[3] = 0x03;
	cmd[4] = 0x00;
	cmd[5] = 0x00;
	if(sendCommand(hcom, cmd, 6, FALSE))
	{
		Log("Send failed\r\n");
		goto error;
	}
	if(ReadByte(hcom) != 0x06)
	{
		Log("NAK\r\n");
		goto error;
	}
	if(getResult(hcom, &data, &size))
	{
		Log("Read error\r\n");
		goto error;
	}
	Log("OK\r\n");

	Log("endComm...");
	if(endComm(hcom))
	{
		Log("failed\r\n");
		return;
	}
	Log("OK\r\n");

	Log("Parsing...");
	{
		BYTE* b = data;
		DWORD i = 0;

		ListView_DeleteAllItems(GetDlgItem(hWnd, IDC_ADDRLIST));

		while((DWORD)(b - data) < size)
		{
			BOOL inserted = FALSE;
			int telcount = 1;
			int teltypecount = 1;
			int emlcount = 1;
			int emltypecount = 1;

			if(*b != 0x1C)
			{
				Log("RecordFirst not found\r\n");
				goto parseError;
			}
			b++;

			while((DWORD)(b - data) < size)
			{
				WORD psize;
				char buf[256];
				char cn[32];
				BYTE cmd;

				if(*b == 0x1C)
					break;

				if(*b != 0x1E)
				{
					Log("RecordByte not found\r\n");
					goto parseError;
				}
				b++;

				cmd = *b++;

				psize = (b[0] << 8) | b[1];
				b += 2;

				if(!inserted && cmd != 0x0B)
				{
					LV_ITEM lvi;

					lvi.mask = 0;
					lvi.iItem = i;
					lvi.iSubItem = 0;
					ListView_InsertItem(GetDlgItem(hWnd, IDC_ADDRLIST), &lvi);

					inserted = TRUE;
				}

				switch(cmd)
				{
				case 0x01:	// name
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Name", buf);
					break;
				case 0x02:	// furigana
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Yomi", buf);
					break;
				case 0x03:	// tel
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					wsprintf(cn, "Tel%d", telcount);
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, cn, buf);

					telcount++;
					break;
				case 0x04:	// tel type
					{
						char* type[] = {"-", "Work", "Home", "FAX", "CellPhone", "PHS", "-"};
						if((b[0] & 0xEF) <= 0x06)
							strcopy(buf, type[b[0] & 0xEF]);
						else
							wsprintf(buf, "%02X", b[0]);
						if(b[0] & 0x10)
							strplus(buf, "(Pre)");
						wsprintf(cn, "Tel%d Type", teltypecount);
						ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, cn, buf);
					}

					teltypecount++;
					break;
				case 0x05:	// email
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					wsprintf(cn, "E-Mail%d", emlcount);
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, cn, buf);

					emlcount++;
					break;
				case 0x06:	// email type
					{
						char* type[] = {"00", "01", "Home", "CellPhone", "PHS", "School", "Work", "-"};
						if((b[0] & 0xEF) <= 0x07)
							strcopy(buf, type[b[0] & 0xEF]);
						else
							wsprintf(buf, "%02X", b[0]);
						if(b[0] & 0x10)
							strplus(buf, "(Pre)");
						wsprintf(cn, "E-Mail%d Type", emltypecount);
						ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, cn, buf);
					}

					emltypecount++;
					break;
				case 0x07:	// secret
					if(b[0] == 0x01)
						ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Secret", "No");
					else
						if(b[0] == 0x02)
							ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Secret", "Yes");
						else
						{
							char tmp[3];
							wsprintf(tmp, "%02X", b[0]);
							ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Secret", tmp);
						}
					break;
				case 0x0C:	// Memo
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Memo", buf);
					break;
				case 0x0A:	// Group
					if(((b[0] << 8) | b[1]) < 20)
						strcopy(buf, group[(b[0] << 8) | b[1]]);
					else
						wsprintf(buf, "%d", (b[0] << 8) | b[1]);
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Group", buf);
					break;
				case 0x0B:	// Mem No.
					wsprintf(buf, "%d", (b[0] << 8) | b[1]);
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "No", buf);
					break;
				case 0x08:	// Addr
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Address", buf);
					break;
				case 0x0E:	// GPS
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "GPS", buf);
					break;
				case 0x0F:	// Picture
					strnncopy(buf, b, strlength(b));
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Picture", buf);
					break;
				case 0x10:	// Reg.date
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "RegDate", buf);
					break;
				case 0x11:	// blood type
					{
						char* btype[] = {"00", "A", "B", "O", "AB", "-"};
						ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "BloodType", btype[b[0]]);
					}
					break;
				case 0x12:	// astro12
					{
						char* astro[] = {"00", "Ђ", "", "oq", "ɍ", "", "", "V", "", "č", "€", "݂ߍ", "", "ւт", "-"};
						ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Astro", astro[b[0]]);
					}
					break;
				case 0x22:	// birthday
					strncopy(buf, b, psize);
					buf[psize] = '\0';
					ListView_SetItemTextByName(GetDlgItem(hWnd, IDC_ADDRLIST), i, "Birthday", buf);
					break;
				default:
					Log("Unknown address field ");
					LogHex(cmd);
					Log(":");
					LogDump(b, psize);
					Log("\r\n");
					break;
				}

				b += psize;
			}

			if(inserted)
				i++;
		}
	}
parseError:
	Log("OK\r\n");

	hfree(data);

	return;
groupParseError:
	hfree(data);
error:
	if(endComm(hcom))
		CloseHandle(hcom);
	return;
}

//̕\
void DrawListItemText(HDC hdc,char *Text,RECT *rc,int fmt)
{
    DRAWTEXTPARAMS  DrawTextExParam;
    int     Justify;

    //ׂ荇񂪂Ȃ悤ɍEɃ}[WB
    //AE}[W͕̔zuE񂹂ɂƂtB
    DrawTextExParam.cbSize=sizeof(DrawTextExParam);
    DrawTextExParam.iLeftMargin=2;
    DrawTextExParam.iRightMargin=0;
    DrawTextExParam.iTabLength=0;
    DrawTextExParam.uiLengthDrawn=0;

    //TuACe̔̕zu𒲂ׂāADrawTextExp̃X^CɒB
    if((fmt & LVCFMT_JUSTIFYMASK)==LVCFMT_LEFT)         Justify=DT_LEFT;
    else if((fmt & LVCFMT_JUSTIFYMASK)==LVCFMT_RIGHT){  Justify=DT_RIGHT;
                                                        DrawTextExParam.iRightMargin=3;}
    else                                                Justify=DT_CENTER;
    //̕\@E}[W̂DrawTextExgĂB
    DrawTextEx(hdc,Text, lstrlen(Text),rc,
        Justify | DT_VCENTER | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX,
        &DrawTextExParam);
}

BOOL CALLBACK AddrWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		SendMessage(GetDlgItem(hWnd, IDC_ADDRLIST), LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT, 0xFFFFFFFF);

		{
			LV_COLUMN lvc;

			lvc.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_FMT;

			lvc.fmt = LVCFMT_RIGHT;

			lvc.cx = 40;
			lvc.pszText = "No";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.fmt = LVCFMT_LEFT;

			lvc.cx = 100;
			lvc.pszText = "Name";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Yomi";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Tel1";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "Tel1 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Tel2";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "Tel2 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Tel3";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "Tel3 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Tel4";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "Tel4 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Tel5";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "Tel5 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "E-Mail1";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "E-Mail1 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "E-Mail2";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "E-Mail2 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "E-Mail3";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "E-Mail3 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "E-Mail4";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "E-Mail4 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "E-Mail5";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "E-Mail5 Type";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 40;
			lvc.pszText = "Secret";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Memo";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Group";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Address";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "GPS";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Picture";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "RegDate";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 40;
			lvc.pszText = "BloodType";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 60;
			lvc.pszText = "Astro";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);

			lvc.cx = 100;
			lvc.pszText = "Birthday";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_ADDRLIST), ListView_GetColumnCount(GetDlgItem(hWnd, IDC_ADDRLIST)), &lvc);
		}
		return TRUE;	// set focus
	case WM_LBUTTONDOWN:
		SendMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0);
		break;
	case WM_CLOSE:
		EndDialog(hWnd, 0);
		hAddrWnd = NULL;
		EmojiUnprecache();
		break;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case 0:
			switch(LOWORD(wParam))
			{
			case IDOK:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			case IDC_GETADDR:
				getAddresses(hWnd);
				break;
			case ID_SAVEADDRPICTURE:
				break;
			case ID_EDITADDR:
				break;
			case ID_DELETEADDR:
				{
					char tmp[80];

					wsprintf(tmp, "YOU WILL LOST %d ITEM(S)!\n\nA R E  Y O U  S U R E ?", ListView_GetSelectedCount(GetDlgItem(hWnd, IDC_ADDRLIST)));
					if(MessageBox(hWnd, tmp, "WARNING", MB_ICONWARNING | MB_YESNO) == IDYES)
					{
						int i;

						for(i = 0; i < ListView_GetItemCount(GetDlgItem(hWnd, IDC_ADDRLIST)); i++)
							if(ListView_GetItemState(GetDlgItem(hWnd, IDC_ADDRLIST), i, LVIS_SELECTED))
							{
								;
							}
					}
				}
				break;
			}
		}
		break;
		/*
	case WM_MEASUREITEM:
		if(wParam == IDC_ADDRLIST)
		{
			LPMEASUREITEMSTRUCT mis = (LPMEASUREITEMSTRUCT)lParam;

			mis->itemHeight = 18;

			return TRUE;
		}
		break;
		*/
	case WM_DRAWITEM:
		if(wParam == IDC_ADDRLIST)
		{
			LPDRAWITEMSTRUCT lpDraw = (LPDRAWITEMSTRUCT)lParam;
			HDC hdc = lpDraw->hDC;
			HWND hList = lpDraw->hwndItem;

			HBRUSH oldbrs;

			SaveDC(hdc);

			SetBkMode(hdc, OPAQUE);

			if(lpDraw->itemState & ODS_SELECTED)
			{
				oldbrs = SelectObject(hdc, CreateSolidBrush(GetSysColor(COLOR_HIGHLIGHT)));
				SetBkColor(hdc, GetSysColor(COLOR_HIGHLIGHT));
				SetTextColor(hdc, GetSysColor(COLOR_HIGHLIGHTTEXT));
			}else
			{
				COLORREF col = ListView_GetTextBkColor(hList);
				if(col & 0xff000000)
					col = GetSysColor(COLOR_WINDOW);
				oldbrs = SelectObject(hdc, CreateSolidBrush(col));
			}

			{
				RECT rcEntire, rcItem, rcClient;
				int i;
				LV_COLUMN lvc;
				char Text[256];

				lvc.mask = LVCF_FMT;
				ListView_GetColumn(hList, 0, &lvc);

				ListView_GetItemRect(hList, lpDraw->itemID, &rcEntire, LVIR_BOUNDS);
				ListView_GetItemRect(hList, lpDraw->itemID, &rcItem, LVIR_LABEL);
				rcEntire.left = rcItem.left;

				GetClientRect(hList, &rcClient);
				if(rcEntire.right<rcClient.right)
					rcEntire.right = rcClient.right;
				FillRect(hdc,&rcEntire,GetCurrentObject(hdc, OBJ_BRUSH));

				{
					LV_ITEM lvi;
//					HIMAGELIST hImage;

					lvi.mask = LVIF_TEXT | LVIF_IMAGE;
					lvi.iItem = lpDraw->itemID;
					lvi.iSubItem = 0;
					lvi.pszText = Text;
					lvi.cchTextMax = sizeof(Text);
					ListView_GetItem(hList, &lvi);

#if 0
					//C[WXg̃nh擾
					hImage = ListView_GetImageList(hList, LVSIL_SMALL);
					//C[WXgo^ĂƂAC[W\B
					//C[Wԍ́AiImageoɂB
					if(hImage){
						ListView_GetItemRect(hList, lpDraw->itemID, &rcItem, LVIR_ICON);
						//ImageList_Draw(hImage, lvi.iImage, hdc, rcItem.left, rcItem.top, /*?*/((lpDraw->itemState & ODS_SELECTED)? ILD_FOCUS:ILD_NORMAL) |ILD_TRANSPARENT);
					}
#endif

					//\BListView_GetItemRectgƕ\̈悪B
					ListView_GetItemRect(hList, lpDraw->itemID, &rcItem, LVIR_LABEL);
					DrawListItemText(hdc, Text, &rcItem, lvc.fmt);
				}

				for(i = 1; i <= Header_GetItemCount(ListView_GetHeader(hList)) - 1; i++)
				{
					ListView_GetSubItemRect(hList, lpDraw->itemID, i, LVIR_BOUNDS, &rcItem);
					FillRect(hdc, &rcItem, GetCurrentObject(hdc, OBJ_BRUSH));

					ListView_GetColumn(hList, i, &lvc);
					ListView_GetSubItemRect(hList, lpDraw->itemID, i, LVIR_LABEL, &rcItem);

					ZeroMemory(Text, sizeof(Text));
					ListView_GetItemText(hList, lpDraw->itemID, i, Text, sizeof(Text));

					if(i == 6 || i == 9)	// memo
					{
						// GƂB
						//DrawListItemText(hdc, Text, &rcItem, lvc.fmt);
						BYTE* b = Text;

						rcItem.left += 2;
						rcItem.top += 1;

						while(*b)
						{
							DWORD j;
							BOOL drawed = FALSE;

							if(IsDBCSLeadByte(*b))
								for(j = 0; !drawed && j < EmojiItems(); j++)
									if(*b == HIBYTE(emoji[j].code) && *(b + 1) == LOBYTE(emoji[j].code))
									{
										HDC hdcx;
										HBITMAP hbmp, hobmp;

										if(!emoji[j].image)
											if(EmojiLoad(j))
											{
												static BOOL warn = FALSE;

												if(!warn)
												{
													MessageBox(hWnd, "emojifBNgpngǂݏo܂B\nkm.txtɏ]ĊGpng𐶐ĂB", "Error", MB_ICONERROR | MB_OK);
													warn = TRUE;
												}
											}

										hdcx = CreateCompatibleDC(hdc);
										hbmp = CreateBitmap(emoji[j].image->width, emoji[j].image->height, 1, 32, emoji[j].image->image);
										hobmp = SelectObject(hdcx, hbmp);
										//BitBlt(hdc, rcItem.left, rcItem.top, width, height, hdcx, 0, 0, SRCCOPY);
										StretchBlt(hdc, rcItem.left, rcItem.top, rcItem.bottom - rcItem.top, rcItem.bottom - rcItem.top, hdcx, 0, 0, emoji[j].image->width, emoji[j].image->height, SRCCOPY);
										DeleteObject(SelectObject(hdcx, hobmp));
										DeleteDC(hdcx);

										rcItem.left += rcItem.bottom - rcItem.top;

										drawed = TRUE;
									}

							if(!drawed)
							{
								DrawText(hdc, b, IsDBCSLeadByte(*b) ? 2 : 1, &rcItem, DT_NOCLIP	| DT_LEFT);
								{
									SIZE s;
									GetTextExtentPoint32(hdc, b, IsDBCSLeadByte(*b) ? 2 : 1, &s);
									rcItem.left += s.cx;
								}
							}
							b = CharNext(b);

							if(rcItem.left > rcItem.right)
								break;
						}
					}else
						DrawListItemText(hdc, Text, &rcItem, lvc.fmt);
				}

				if (lpDraw->itemState & ODS_FOCUS){
					rcEntire.bottom--;
					DrawFocusRect(hdc,&rcEntire);
				}
			}

			DeleteObject(SelectObject(hdc, oldbrs));

			RestoreDC(hdc, -1);
		}
		break;
	case WM_NOTIFY:
		{
			NMLVDISPINFO* nldi = (NMLVDISPINFO*)lParam;
			switch(nldi->hdr.code)
			{
			case LVN_GETDISPINFO:
				break;
			}
		}
		break;
	case WM_CONTEXTMENU:
		if((HWND)wParam == GetDlgItem(hWnd, IDC_ADDRLIST) && ListView_GetSelectedCount(GetDlgItem(hWnd, IDC_ADDRLIST)))
		{
			HMENU hpm = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_ADDRESSPOPUP));
			HMENU hm = GetSubMenu(hpm, 0);

			TrackPopupMenu(hm, 0, LOWORD(lParam), HIWORD(lParam), 0, hWnd, NULL);

			DestroyMenu(hm);
			DestroyMenu(hpm);
		}
		break;
	}

	return FALSE;
}
