#include "myrt.h"

void ZeroMemory(void* ptr, DWORD size)
{
	while(size--)
		*(((char*)ptr)++) = 0;

	return;
}


VOID strcopy(LPSTR dst, LPCSTR src)
{
	while(*src)	*dst++ = *src++;
	*dst = *src;	// copy null

	return;
}

DWORD strlength(LPCSTR src)
{
	DWORD result = 0;

	while(*src++)	result++;

	return result;
}

int strcomp(const char* p, const char *q)
{
	if(!p || !q)	return 0;
	if(p == q)		return 0;

	for(; *p == *q && *p != '\0'; p++, q++);

	return *p - *q;
}

void strplus(char* p, const char *c)
{
	if(!p || !c || p == c)	return;

	p += strlength(p);	// NULLO܂Ő
	strcopy(p, c);		// strcopyB

	return;
}

void* halloc(DWORD size)
{
	return HeapAlloc(GetProcessHeap(), 0, size);
}

void hfree(void* ptr)
{
	if(ptr)	HeapFree(GetProcessHeap(), 0, ptr);

	return;
}

void* hrealloc(void* ptr, DWORD size)
{
	if(ptr)
		return HeapReAlloc(GetProcessHeap(), 0, ptr, size);
	else
		return halloc(size);
}

VOID strncopy(LPSTR dst, LPCSTR src, DWORD size)
{
	while(*src && size--)
		*dst++ = *src++;

	return;
}

VOID strnncopy(LPSTR dst, LPCSTR src, DWORD size)
{
	while(*src && size--)
		*dst++ = *src++;
	if(!*src)
		*dst = *src;

	return;
}

void addEndYen(char* str)
{
	char* p = str;
	char* yen = str;

	while(*p)
	{
		if(!IsDBCSLeadByte(*p))
			if(*p == '\\')
				yen = p;
		p = CharNext(p);
	}

	if(yen != (str + strlength(str) - 1))
		strplus(str, "\\");

	return;
}

DWORD atodn(char* str, DWORD max)
{
	DWORD res = 0;
	DWORD i;

	for(i = 0; *str && i < max; i++, str++)
		if('0' <= *str && *str <= '9')
			res = res * 10 + (*str - '0');
		else
			break;

	return res;
}

DWORD atod(char* str)
{
	DWORD res = 0;

	for(; *str; str++)
		if('0' <= *str && *str <= '9')
			res = res * 10 + (*str - '0');
		else
			break;

	return res;
}

int _fltused = 0x1234;

char* basename(const char* str)
{
	char* last = (char*)str;

	while(*str)
	{
		// ANSIȂB
		if(!IsDBCSLeadByte(*str) && *str == '\\')
			last = (char*)str + 1;
		str = CharNext(str);
	}

	return last;
}

char* strclone(const char* str)
{
	char* newbuf;

	if(!(newbuf = halloc(strlength(str) + 1)))
		return NULL;

	strcopy(newbuf, str);

	return newbuf;
}

char* strnclone(const char* str, DWORD len)
{
	char* newbuf;
	DWORD cplen = strlength(str);

	if(len < cplen)
		cplen = len;

	if(!(newbuf = halloc(cplen + 1)))
		return NULL;

	strncopy(newbuf, str, len);
	newbuf[len] = '\0';

	return newbuf;
}
