#include "common.h"
#include "mainWnd.h"
#include "sendWnd.h"
#include "com.h"
#include "kcomm.h"

HWND hSendWnd = NULL;

typedef struct
{
	char* name;
	DWORD size;
} SFCB;

void SendDataCallback(DWORD cur, LPARAM lp)
{
	char tmp[256];

	wsprintf(tmp, "%d%% %d/%d", cur * 100 / ((SFCB*)lp)->size, cur, ((SFCB*)lp)->size);
	SetDlgItemText(hSendWnd, IDC_FILESTATUS, ((SFCB*)lp)->name);
	SetDlgItemText(hSendWnd, IDC_FILEBYTESTATUS, tmp);
	SendMessage(GetDlgItem(hSendWnd, IDC_FILEPROGRESS), PBM_SETPOS, cur * 1000 / ((SFCB*)lp)->size, 0);

	{
		MSG msg;

		while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			DispatchMessage(&msg);
	}

	return;
}

BOOL putFile(char* name, char* fn)
{
	HANDLE hf = NULL;
	BYTE* data = NULL;
	DWORD dsize;
	DWORD read;
	BYTE* cmd = NULL;

	HANDLE hcom = NULL;

	Log("<<PutFile>>\r\n");

	Log("Source Open ");

	if((hf = CreateFile(fn, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
		goto error;

	Log("Reading ");

	dsize = GetFileSize(hf, NULL);

	if(!dsize)
	{
		Log("Can't send size 0\r\n");
		goto error;
	}

	if(!(data = halloc(dsize)))
		goto error;

	if(!ReadFile(hf, data, dsize, &read, NULL))
		goto error;

	CloseHandle(hf), hf = NULL;

	Log("OK\r\n");
	Log("Sending...");

	if(beginComm(&hcom))
		goto error;

	Log("SetFile...");

	if(!(cmd = halloc(2 + strlength(name) + 1 + 4)))
		goto error;

	cmd[0] = 0x01;
	cmd[1] = 0x10;
	strcopy(cmd + 2, name);
	cmd[2 + strlength(name) + 1 + 0] = (BYTE)((dsize >> 24) & 0xFF);
	cmd[2 + strlength(name) + 1 + 1] = (BYTE)((dsize >> 16) & 0xFF);
	cmd[2 + strlength(name) + 1 + 2] = (BYTE)((dsize >>  8) & 0xFF);
	cmd[2 + strlength(name) + 1 + 3] = (BYTE)((dsize      ) & 0xFF);

	if(sendCommand(hcom, cmd, 2 + strlength(name) + 1 + 4, FALSE))
		goto error;
	if(ReadByte(hcom) != 0x06)
	{
		Log("NAK");
		goto error;
	}

	hfree(cmd), cmd = NULL;

	Log("data...");

	{
		SFCB sfcb;

		sfcb.name = name;
		sfcb.size = dsize;

		if(sendCommandWC(hcom, data, dsize, TRUE, SendDataCallback, (LPARAM)&sfcb))
			goto error;
	}

	Log("Closing...");

	if(endComm(hcom))
		goto error;
	hcom = NULL;

	Log("OK\r\n");

	hfree(data);

	return FALSE;
error:
	Log("failed\r\n");
	if(hf)
		CloseHandle(hf);
	if(data)
		hfree(data);
	if(cmd)
		hfree(cmd);
	if(hcom)
		if(endComm(hcom))
			CloseHandle(hcom);
	return TRUE;
}

BOOL checkDuplicate(char* fn)
{
	DWORD j;
	char item[MAX_PATH];

	DWORD items = ListView_GetItemCount(GetDlgItem(hSendWnd, IDC_SENDFILELIST));

	for(j = 0; j < items; j++)
	{
		ListView_GetItemText(GetDlgItem(hSendWnd, IDC_SENDFILELIST), j, 0, item, sizeof(item));

		if(!lstrcmpi(item, fn))
		{
			ListView_GetItemText(GetDlgItem(hSendWnd, IDC_SENDFILELIST), j, 1, item, sizeof(item));

			if(strcomp(item, "OK"))
				break;	// duplicated.
		}
	}

	if(j < items)
		return TRUE;
	else
		return FALSE;
}

void addList(char* fname)
{
	if(!checkDuplicate(fname))
	{
		LV_ITEM lvi;
		HANDLE hf;

		lvi.mask = LVIF_TEXT;
		lvi.iItem = ListView_GetItemCount(GetDlgItem(hSendWnd, IDC_SENDFILELIST));
		lvi.iSubItem = 0;
		lvi.pszText = fname;
		ListView_InsertItem(GetDlgItem(hSendWnd, IDC_SENDFILELIST), &lvi);

		if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
		{
			ListView_SetItemText(GetDlgItem(hSendWnd, IDC_SENDFILELIST), lvi.iItem, 1, "(404)");
		}else
		{
			ListView_SetItemText(GetDlgItem(hSendWnd, IDC_SENDFILELIST), lvi.iItem, 1, "Ready");
			CloseHandle(hf);
		}
	}

	return;
}

BOOL CALLBACK SendWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		SendMessage(GetDlgItem(hWnd, IDC_SENDFILELIST), LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT, 0xFFFFFFFF);

		SetDlgItemText(hWnd, IDC_TOTALSTATUS, "Drag files that you want to send");
		SetDlgItemText(hWnd, IDC_FILESTATUS, "into this dialog and click [Send].");
		SetDlgItemText(hWnd, IDC_FILEBYTESTATUS, "");
		SendMessage(GetDlgItem(hWnd, IDC_TOTALPROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, 1));
		SendMessage(GetDlgItem(hWnd, IDC_TOTALPROGRESS), PBM_SETPOS, 0, 0);
		SendMessage(GetDlgItem(hWnd, IDC_FILEPROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, 1000));
		SendMessage(GetDlgItem(hWnd, IDC_FILEPROGRESS), PBM_SETPOS, 0, 0);

		{
			LV_COLUMN lvc;

			lvc.mask = LVCF_WIDTH | LVCF_TEXT;

			lvc.cx = 300;
			lvc.pszText = "Filename";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_SENDFILELIST), 0, &lvc);

			lvc.cx = 60;
			lvc.pszText = "Status";
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_SENDFILELIST), 1, &lvc);
		}

		// arg present
		if(lParam)
		{
			char* arg = (char*)lParam;

			hSendWnd = hWnd;

			while(*arg)
			{
				char* b = arg;

				// pickup filename and add to list!

				if(*arg == '"')
				{
					arg++;
					b++;
					while(*b && *b != '"')
						b++;
				}else
					while(*b && *b != ' ')
						b++;

				{
					char* fn;

					fn = strnclone(arg, b - arg);
					addList(fn);
					hfree(fn);
				}

				if(*b == '"')
					b++;
				if(*b)
					b++;
				arg = b;
			}
		}

		break;
	case WM_CLOSE:
		PostMessage(hWnd, WM_COMMAND, IDCANCEL, 0);
		break;
	case WM_LBUTTONDOWN:
		SendMessage(hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0);
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hWnd, 0);
			hSendWnd = NULL;
			break;
		case IDC_CLEARLIST:
			ListView_DeleteAllItems(GetDlgItem(hWnd, IDC_SENDFILELIST));
			break;
		case IDC_SENDFILES:
			EnableWindow(GetDlgItem(hWnd, IDC_SENDFILES), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_ADDFILE), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDCANCEL), FALSE);

			SetDlgItemText(hWnd, IDC_TOTALSTATUS, "Sending files...");
			SetDlgItemText(hWnd, IDC_FILESTATUS, "");
			SendMessage(GetDlgItem(hWnd, IDC_TOTALPROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, ListView_GetItemCount(GetDlgItem(hWnd, IDC_SENDFILELIST))));
			SendMessage(GetDlgItem(hWnd, IDC_TOTALPROGRESS), PBM_SETPOS, 0, 0);

			{
				int i;
				int max = ListView_GetItemCount(GetDlgItem(hWnd, IDC_SENDFILELIST));

				for(i = 0; i < max; i++)
				{
					char tmp[256];

					ListView_GetItemText(GetDlgItem(hWnd, IDC_SENDFILELIST), i, 1, tmp, sizeof(tmp));

					if(strcomp(tmp, "OK"))
					{
						{
							char tmp[80];

							wsprintf(tmp, "Sending files...(%d/%d)", i, max);
							SetDlgItemText(hWnd, IDC_TOTALSTATUS, tmp);
						}
						ListView_SetItemText(GetDlgItem(hWnd, IDC_SENDFILELIST), i, 1, "Sending");
						SendMessage(GetDlgItem(hWnd, IDC_TOTALPROGRESS), PBM_SETPOS, i, 0);

						SetDlgItemText(hWnd, IDC_FILESTATUS, basename(tmp));

						ListView_GetItemText(GetDlgItem(hWnd, IDC_SENDFILELIST), i, 0, tmp, sizeof(tmp));
						if(putFile(basename(tmp), tmp))
						{
							ListView_SetItemText(GetDlgItem(hWnd, IDC_SENDFILELIST), i, 1, "Err");
						}else
						{
							ListView_SetItemText(GetDlgItem(hWnd, IDC_SENDFILELIST), i, 1, "OK");
						}

						SendMessage(GetDlgItem(hWnd, IDC_FILEPROGRESS), PBM_SETPOS, 0, 0);
						SetDlgItemText(hWnd, IDC_FILESTATUS, "");
						SetDlgItemText(hWnd, IDC_FILEBYTESTATUS, "");
					}

					{
						MSG msg;

						while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
							DispatchMessage(&msg);
					}
				}
			}

			SetDlgItemText(hWnd, IDC_TOTALSTATUS, "Send accomplished.");
			SendMessage(GetDlgItem(hWnd, IDC_TOTALPROGRESS), PBM_SETPOS, 0, 0);
			SetDlgItemText(hWnd, IDC_FILESTATUS, "");
			SetDlgItemText(hWnd, IDC_FILEBYTESTATUS, "");

			EnableWindow(GetDlgItem(hWnd, IDC_SENDFILES), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_ADDFILE), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDCANCEL), TRUE);
			break;
		case IDC_ADDFILE:
			{
				OPENFILENAME ofn = {0};
				char fname[MAX_PATH];
				char name[MAX_PATH];

				ofn.lStructSize = sizeof(ofn);
				ofn.Flags = OFN_FILEMUSTEXIST;
				ofn.hInstance = GetModuleHandle(NULL);
				ofn.hwndOwner = hWnd;
				fname[0] = '\0';
				ofn.lpstrFile = fname;
				ofn.nMaxFile = sizeof(fname);
				ofn.lpstrFileTitle = name;
				ofn.nMaxFileTitle = sizeof(name);
				ofn.lpstrFilter = "All files(*.*)\0*.*\0";
				ofn.lpstrTitle = "Send file";

				if(GetOpenFileName(&ofn))
					addList(fname);
			}
			break;
		case ID_REMOVE:
			{
				int i = 0;

				while(i < ListView_GetItemCount(GetDlgItem(hWnd, IDC_SENDFILELIST)))
					if(ListView_GetItemState(GetDlgItem(hWnd, IDC_SENDFILELIST), i, LVIS_SELECTED) & LVIS_SELECTED)
						ListView_DeleteItem(GetDlgItem(hWnd, IDC_SENDFILELIST), i);
					else
						i++;
			}
			break;
		}
		break;
	case WM_DROPFILES:
		{
			DWORD i;
			DWORD max;

			max = DragQueryFile((HDROP)wParam, 0xFFFFFFFF, NULL, 0);

			for(i = 0; i < max; i++)
			{
				char fn[MAX_PATH];

				DragQueryFile((HDROP)wParam, i, fn, sizeof(fn));

				addList(fn);
			}

			DragFinish((HDROP)wParam);
		}
		break;
	case WM_CONTEXTMENU:
		if((HWND)wParam == GetDlgItem(hWnd, IDC_SENDFILELIST) && ListView_GetSelectedCount(GetDlgItem(hWnd, IDC_SENDFILELIST)))
		{
			HMENU hpm = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_SENDFILEPOPUP));
			HMENU hm = GetSubMenu(hpm, 0);

			TrackPopupMenu(hm, 0, LOWORD(lParam), HIWORD(lParam), 0, hWnd, NULL);

			DestroyMenu(hm);
			DestroyMenu(hpm);
		}
		break;
	}

	return FALSE;
}
